/*************************************************************************
* My-T-Soft Utility
* Copyright (C) 1997-2001 by Innovation Management Group, Inc.
* All Rights Reserved.
*************************************************************************/
/*************************************************************************
* DISCLAIMER
* The source code & derived executable are provided at no cost as
* useful & instructional materials to developers & system integrators
* incorporating IMG software.  Because no licensing fee has been
* tendered, there is no technical support offered for this software,
* source code, or its capabilities to solve a particular problem.
*************************************************************************/
/*************************************************************************
* Base Windows structure w/ debug source
* Modified Utility Source for application that Closes My-T-Soft
* & exits with no other actions, no Window display
* Note: Various variables and other window work left in place, but
* has no effect for this application
*************************************************************************/
/*************************************************************************
* START OF CODE
*************************************************************************/
/*************************************************************************
* includes
*************************************************************************/
#include <windows.h>
#include <stdlib.h>
#include "mytsoft.h"

/*************************************************************************
* Variables
*************************************************************************/

char szAppName[30] = "SetCursor for My-T-Soft";
char szCmd[200];  //location for Window command line

HWND hWindow;
HANDLE hInst;

HANDLE hIns;

int OrgX,OrgY,OrgW,OrgH;
int OffsetX,OffsetY;
int MaxX,MaxY,MinX,MinY;

/*************************************************************************
* Functions
*************************************************************************/
LPSTR lstrchr(LPSTR str,char ch);
LPSTR lstrrchr(LPSTR str,char ch);
HWND FindMyTSoft(void);

/*************************************************************************
* WinMain
*************************************************************************/
#ifdef MYTWIN32
int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpszCmdParam,int nCmdShow)
#else
int PASCAL WinMain(HANDLE hInstance,HANDLE hPrevInstance,LPSTR lpszCmdParam,int nCmdShow)
#endif
{
 HWND	hwnd;
 MSG msg;
 WNDCLASS wndclass;
 int x,y,w,h;

 lstrcpy((LPSTR) szCmd,(LPSTR) lpszCmdParam);
 UNREFPARM(nCmdShow);

 if (!hPrevInstance)
 {
	wndclass.style           = CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS;
	wndclass.lpfnWndProc     = (WNDPROC) WndProc;
	wndclass.cbClsExtra      = 0;
	wndclass.cbWndExtra      = 0;
	wndclass.hInstance       = hInstance;
	wndclass.hIcon           = LoadIcon(hInstance,MAKEINTRESOURCE(THEICON));
	wndclass.hCursor         = LoadCursor(NULL,IDC_ARROW);
	wndclass.hbrBackground   = (HBRUSH) GetStockObject(BLACK_BRUSH);
	wndclass.lpszMenuName    = NULL;
	wndclass.lpszClassName   = szAppName;

	RegisterClass(&wndclass);
 }
 //OrgW = w = GetSystemMetrics(SM_CXSCREEN);
 //OrgH = h = GetSystemMetrics(SM_CYSCREEN);
 //x = (GetSystemMetrics(SM_CXSCREEN) /2) - (w/2);
 //y = (GetSystemMetrics(SM_CYSCREEN) /2) - (h/2);

 //MaxX = w - 100;
 //MaxY = h - 100;
 //MinX = MaxX / 10;
 //MinY = MaxY / 10;
 //OffsetX = MaxX / 2;
 //OffsetY = MaxY / 2;

 //OrgX = x;OrgY = y;
 w = h = 0;
 x = GetSystemMetrics(SM_CXSCREEN) + 1;
 y = GetSystemMetrics(SM_CYSCREEN) + 1;

 hwnd = CreateWindow(szAppName,szAppName,
//						 WS_THICKFRAME | WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX | WS_MAXIMIZEBOX,
						 WS_DISABLED | WS_THICKFRAME | WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX | WS_MAXIMIZEBOX,
									 x,y,w,h,
									 NULL,NULL,hInstance,NULL);
 hInst = hInstance;

 hWindow = hwnd;

 //ShowWindow(hwnd,nCmdShow);
 ShowWindow(hwnd,SW_HIDE);
 UpdateWindow(hwnd);
 PostMessage(hwnd,WM_COMMAND,TRUE,0);

 while (GetMessage(&msg,NULL,0,0))
 {
	TranslateMessage(&msg);
	DispatchMessage(&msg);
 }

 return msg.wParam;
}
/*************************************************************************
* WndProc
*************************************************************************/
#ifdef MYTWIN32
LRESULT WINAPI WndProc(HWND hwnd,UINT message,UINT wParam,LONG lParam)
{
 char cWork[25];
 PAINTSTRUCT ps;
 HWND hWork;
 LPSTR lps,lpx,lpy;
 int x,y;

#else  //MYTWIN32
long FAR PASCAL WndProc(HWND hwnd,WORD message,WORD wParam,LONG lParam)
{
 char cWork[25];
 MSG msg;
 LONG lSelect,lWork;
 PAINTSTRUCT ps;
 OFSTRUCT of;
 WORD wEnable,wLine,wString,wMessage1;
 HWND hTemp,hWork;
 LPSTR lpClassName;
 HBITMAP hBitmap,hOldbit;
 HFONT hOldfont;
 HPEN hPen,hOldpen;
 HBRUSH hBrush,hOldbrush;
 POINT pPoint;
 RECT rect;
 HDC hDC,hDCmem;
 HANDLE hResource,hData;
 LPSTR lps,lpx,lpy,lpData;
 int i,j,k;
 int x,y,z;

#endif

 switch (message)
 {
	case WM_SIZE:
	 break;
  case WM_COMMAND:
   if (wParam)
   {
    hWork = FindMyTSoft();
    if (hWork)
    {
     //set cursor based on command line
     //expects x: or X: and y: or Y:
     x = y = 0;
     lpx = lstrchr((LPSTR) szCmd,'x');
     lps = lstrchr((LPSTR) szCmd,'X');
     if ((lps) && (!lpx)) lpx = lps;
     if (lpx)
     {
      lpx += 2;  //past x:
      lps = lstrchr(lpx,' ');
      if (lps) *lps = 0;
      lstrcpy((LPSTR) cWork,lpx);
      if (lps) *lps = ' ';
      x = atoi(cWork);
     }
     lpy = lstrchr((LPSTR) szCmd,'y');
     lps = lstrchr((LPSTR) szCmd,'Y');
     if ((lps) && (!lpy)) lpy = lps;
     if (lpy)
     {
      lpy += 2;  //past y:
      lps = lstrchr(lpy,' ');
      if (lps) *lps = 0;
      lstrcpy((LPSTR) cWork,lpy);
      y = atoi(cWork);
     }
     if ((lpx) || (lpy))
     {
      SetCursorPos(x,y);
     }

     PostMessage(hwnd,WM_CLOSE,0,0);
    }
    else
    {
     //no My-T-Soft found!
     MessageBeep(MB_ICONEXCLAMATION);
     PostMessage(hwnd,WM_CLOSE,0,0);
    }
   }
   return 0;

	case WM_PAINT:
	 BeginPaint(hwnd,&ps);
	 EndPaint(hwnd,&ps);
	 break;
	case WM_LBUTTONDOWN:
	 break;
  case WM_LBUTTONDBLCLK:
	 break;
	case WM_RBUTTONDOWN:
	 break;
  case WM_RBUTTONDBLCLK:
	 break;
	case WM_MBUTTONDOWN:
	 break;

	case WM_CLOSE:
	 DestroyWindow(hwnd);
	 return 0;
	case WM_DESTROY:
	 PostQuitMessage(0);
	 return 0;
 }
 return DefWindowProc(hwnd,message,wParam,lParam);
}
/*************************************************************************
* lstrchr(LPSTR str,char ch)
*************************************************************************/
LPSTR lstrchr(LPSTR str,char ch)
{
 while (*str)
 {
	if (ch == *str) return str;
	str = AnsiNext(str);
 }
 return NULL;
}
/*************************************************************************
* lstrrchr(LPSTR str,char ch)
*************************************************************************/
LPSTR lstrrchr(LPSTR str,char ch)
{
 LPSTR strl = str + lstrlen(str);
 do
 {
	if (ch == *strl) return strl;
	strl = AnsiPrev(str,strl);
 } while (strl > str);
 return NULL;
}
/*************************************************************************
* FindMyTSoft identifies handle of window in My-T-Soft Family
*************************************************************************/
HWND FindMyTSoft(void)
{
 HWND hTemp;

 // Should be a library function, but want it available for users
 // of developer's kit to play with...

 hTemp = FindWindow(NULL,(LPSTR) "My-T-Soft");
 if (!hTemp) hTemp = FindWindow(NULL,(LPSTR) "My-T-Touch");
 if (!hTemp) hTemp = FindWindow(NULL,(LPSTR) "My-T-Pen");
 if (!hTemp) hTemp = FindWindow(NULL,(LPSTR) "My-T-Mouse");
 if (!hTemp) hTemp = FindWindow(NULL,(LPSTR) "My-T-Mouse for Kids");
 if (!hTemp) hTemp = FindWindow(NULL,(LPSTR) "TouchType");
 if (!hTemp) hTemp = FindWindow(NULL,(LPSTR) "FastPoint");
 if (!hTemp) hTemp = FindWindow(NULL,(LPSTR) "EasyKey");
 if (!hTemp) hTemp = FindWindow(NULL,(LPSTR) "JobPack");
 if (!hTemp) hTemp = FindWindow(NULL,(LPSTR) "OnScreen");
 return hTemp;
}
/*************************************************************************
* END OF CODE
*************************************************************************/
